#!/usr/bin/python
from experimental import *
from mine_overlap import *

ACTIONS = {"dos": findDensestDOS,
           "overn": findDensestOverN,
           "front": getFrontDOS
           }

################ MAIN
def run(args):
    org_parameters = None
    if len(args) > 1:
        action = args[1]
        if len(args) > 2 and os.path.isfile(args[2]):
            fp = open(args[2])
            org_parameters = readParameters(fp)
            fp.close()
    if org_parameters is None:
        Warning("No parameters given")
        exit()

    data_parameters = dict(org_parameters)

    if not action in ACTIONS:
        print "Action %s does not exist..." % action
        exit()
        
    # series = [{}]
    bfs = []
    print "PARAMETERS:\n" + ("\n".join(["  * %s= %s" % (k,v) for (k,v) in data_parameters.items()]))
    #### Load data network from file 
    if action not in ["ego"] and data_parameters.has_key("centers"):
        for centert in data_parameters["centers"].strip(" ;").split(";"):

            center = centert.strip()
            if data_parameters["min_weight"] is None:
                min_weight_s = ""
            else:
                min_weight_s = "-%.1f" % data_parameters["min_weight"]
            bfs.append(("wegonet_%s%d%s.%s" % (center.replace(" ",""), data_parameters["ego"], min_weight_s, data_parameters["graph_ext"]), center))

    elif data_parameters.has_key('graph_file'):
        if "*" in data_parameters['graph_file']:
            starind = data_parameters['graph_file'].index("*")
            fnames = glob.glob(data_parameters['data_rep']+data_parameters['graph_file'])
            fnames.sort(key=lambda x: os.path.getsize(x))
            for gname in fnames:
                ser_b = gname[len(data_parameters['data_rep'])+starind:-len(data_parameters['graph_file'])+starind+1]
                gname = gname[len(data_parameters['data_rep'])::]
                bfs.append((gname, None))
        else:
            bfs.append((data_parameters['graph_file'], None))

    for bf in bfs:
        data_parameters['basis'] = ".".join(bf[0].split(".")[:-1])
        print "--------- %s -------" % data_parameters["basis"]
        cleanCache(data_parameters)
        data_parameters['graph_file'] = data_parameters['data_rep']+ bf[0]
        graph = readGraph(data_parameters['data_rep']+ bf[0], center=bf[-1], min_weight=data_parameters['min_weight'])
        print "Read edges [%d]..." % len(graph)

        store_parameters = data_parameters
        series, store_utils = prepareSeriesLmbd(action, data_parameters)
        print series

        for serie in series:
            data_parameters = dict(store_parameters)
            data_parameters["store_utils"] = store_utils
            data_parameters.update(serie)
            if action not in ["front", "frontmr"]:
                data_parameters['basis'] += "_l%s-%s" % (data_parameters["elmbd"],  data_parameters["serie_suff"])
            ACTIONS[action](graph, data_parameters)

if __name__ == "__main__":
    run(sys.argv)
